#!/usr/bin/perl
#
# dcladmin.cgi - administration utility
# for DCLinks 2000
#
# Part of DCLinks 2000 Version 1.000
# Release date: Jan 20 2000
#
# Revision History
# DCLinks 1998 Release on 16 November 1997
#
##########  YOU MUST KEEP THIS COPYRIGHTS NOTICE INTACT ###############
# Copyright  1997-2000 DCScripts All Rights Reserved
# As part of the installation process, you will be asked
# to accept the terms of this Agreement. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts and DCLinks.
# You should carefully read the following terms and conditions before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# Versions of the Software 
# --------------------------------------------------------------------------
# You may install as many copies of DCLinks Script for free
# on personal and non-profit sites.  Otherwise, a single license
# of DCLinks is $35 (USD).
# 
# License to Redistribute
# --------------------------------------------------------------------------
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# DCScripts's prior written permission is forbidden.
#
# All rights to the DCLinks software and documentation not expressly
# granted under this Agreement are reserved to DCScripts.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH HKDBOARD MAY BE USED, NO WARRANTY OF
# FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF DCSCRIPTS WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL DCSCRIPTS BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# DCSCRIPTS IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# DCSCRIPT'S LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO DCSCRIPTS.
#
###########################################################################

# Define directory path to this script
# If relative path will work leave it as is

$cgidir = "/home/ivpd/public_html/cgi-bin/dclinks";


# ----------------- Shouldn't have to change anything below here --------------#
# inlcude library files...
require "$cgidir/dclinks.setup";
require "$cgidir/cgi-lib.pl";
require "$cgidir/dclinkslib.pl";
require "$cgidir/dcprotect.pl";

# Read in Form data
ReadParse();

$r_in = \%in;

# Print HTTP header but note it doesn't end here
print_header();

# $thisurl is the URL of this script
$thisurl = $dcadmin;

# $password_file_dir is the directory where all
# authentication files will be created and kept
# This directory must be set to 777
$password_file_dir = "$datadir";

# Path to the template file used by dcprotect.pl
$templatefile = $booktemplate;

# setup file name
$in{'auth_setup_file'} = "auth_setup_file.txt";

# password file name
$in{'password_file'} = "auth_user_file.txt";

# cookie expriation date if 'Remember My Password' is used
$in{'expires'} = "Fri, 31-Dec-2010 12:00:00 GMT";

# Cookie name
$in{'cookie_name'} = "DCProtectSessionID";

# Username, Password, and Group are always required
# They are appended at the very beginning of @login_fields
# and %field_input_type in dcprotect subroutine
# Also, Status is appended at the end of @login_fields

@login_fields = qw(Firstname Lastname EMail);
%field_form_type = (
		Firstname => 'text|20|required',
		Lastname => 'text|20|required',
		EMail => 'text|20|required'
);

# Following line adds authentication

$r_userdata = dcprotect($dcadmin,$password_file_dir,\%in,
			\@login_fields,\%field_form_type);

unless ($r_userdata->{'Group'} eq 'admin') {
	$header = "ACCESS DENIED";
	$sub_header = "Only administrator can access this utility";
	display_output();
	exit;
}

$j = -1;
foreach (@link_fields) {
	$j++;
   $field_id{$_} = $j;
}

# If Password file doesn't exist, create one
# with username dcscripts and password dcscripts

$header = $title . " - Administration Utility";
$menu = qq~
<a href="$dcscript">DCLinks Main page</a> |
<a href="$dcadmin">DCLinks Admin</a> |
<a href="$dcadmin?dc_action=configure">Admin Setup</a> |
<a href="$dcadmin?az=login">Logout</a>
~;

if ($in{"action"} eq "remove_links") {
   remove_links();
	if ($ENV{'HTTP_REFERER'} =~ /$dcscript/) {
	   print "Location: $ENV{'HTTP_REFERER'}\n\n";
		exit;
	}
}
elsif ($in{"action"} eq "edit_links") {
   edit_links();
}
else {
   main();
}

print_header();
print_header_end();
display_output();
exit;

sub edit_links {

	$html_output = qq~
	<table border="0" width="$table_width" cellpadding="5" cellspacing="1">
	<tr class="heading">
	<td class="heading" colspan="2">DCLinks Administration Utility - Modify Links</td>
	</tr>
	</table>
	<ul class=my>~;

	my $r_data = readdata("$datafile");
	my @newdata;
   if ($in{'command'} eq "save") {
		my $id = $in{'ID'};
		my @fields;
		my $record;
		foreach (@link_fields) {
			push(@fields,$in{$_});
		}

		$record = join("\|",@fields);
		$record .= "\n";

		for ($j=0;$j<@$r_data;$j++) {
			my $row = $r_data->[$j];
			chomp($row);

			my @fields = split(/\|/,$row);
			if ($fields[0] == $id) {
				$r_data->[$j] = $record;
				last;
		   }
		}

		writedata("$datafile",$r_data);

		if ($in{'origurl'} =~ /$dcscript/) {
		   print "Location: $in{'origurl'}\n\n";
			exit;
		}

	}
   elsif ($in{'command'} eq "edit") {
		my $id = $in{'selected'};
		my @record;

		for $row (@$r_data) {
			chomp($row);
			my @fields = split(/\|/,$row);
			if ($fields[0] == $id) {
				@record = @fields;
				last;
		   }
		}

		$html_output .= qq~
		<form method="post">
		<input type="hidden" name="action" value="$in{'action'}">
		<input type="hidden" name="command" value="save">
		<input type="hidden" name="origurl" value="$ENV{'HTTP_REFERER'}">
		<table border="0" width="$table_width" cellpadding="5" cellspacing="1">
		~;

		foreach (@link_fields) {
			$in{$_} = $record[$field_id{$_}];
			$html_output .= table_row($_,$field_input_type{$_});
		}

		$html_output .= qq~
		</table>
		<br>
		<input type="submit" value="Update Link">
		<input type="reset" value="Reset">
		</form>~;
	}
	else {
		$html_output .= qq~
		<form method="post">
		<input type="hidden" name="action" value="$in{'action'}">
		<input type="hidden" name="command" value="edit">
		~;

		foreach (@$r_data) {
			chomp;
			my @fields = split /\|/;
			$html_output .= qq~
			<dt class=my><input type="radio" name="selected" value="$fields[0]">$fields[$field_id{"ID"}] 
			- $fields[$field_id{"Name"}] ($fields[$field_id{"Homepage"}])</dt>
			~;
		}
		$html_output .= qq~
		<br>
		<input type="submit" value="Edit Selected Link">
		<input type="reset" value="Reset">
		</form>~;
	}

	$html_output .= "</ul>";
}


sub remove_links {

	$html_output = qq~
	<table border="0" width="$table_width" cellpadding="5" cellspacing="1">
	<tr class="heading">
	<td class="heading" colspan="2">DCLinks Administration Utility - Remove Links</td>
	</tr>
	</table>
	<ul class=my>~;

	my $r_data = readdata("$datafile");
	my @newdata;
   if ($in{'command'}) {
	   my @remove_list = split(/\0/,$in{'selected'});
		foreach $row (@$r_data) {

			last if (@remove_list < 1);
			chomp($row);
			my @fields = split(/\|/,$row);
			my $hit = '';

			for ($j=0;$j<@remove_list;$j++) {
				my $id = $remove_list[$j];
				if ($fields[0] == $id) {
					$html_output .= qq~
					<dt class=my>Removed Link ID $fields[$field_id{"ID"}] 
					- $fields[$field_id{"Name"}] ($fields[$field_id{"Homepage"}])</dt>
					~;
					$hit = "yes";
				}
		   }

			unless ($hit) {
				push(@newdata,"$row\n");
			}

		}
		
		writedata("$datafile",\@newdata);

	}
	else {
		$html_output .= qq~
		<form method="post">
		<input type="hidden" name="action" value="$in{'action'}">
		<input type="hidden" name="command" value="remove">
		~;

		foreach (@$r_data) {
			chomp;
			my @fields = split /\|/;
			$html_output .= qq~
			<dt class=my><input type="checkbox" name="selected" value="$fields[0]">$fields[$field_id{"ID"}] 
			- $fields[$field_id{"Name"}] ($fields[$field_id{"Homepage"}])</dt>
			~;
		}
		$html_output .= qq~
		<br>
		<input type="submit" value="Remove Selected Links">
		<input type="reset" value="Reset">
		</form>~;
	}

	$html_output .= "</ul>";
}

sub main {

	$html_output = qq~
	<table border="0" width="$table_width" cellpadding="5" cellspacing="1">
	<tr class="heading">
	<td class="heading" colspan="2">DCLinks Administration Utility</td>
	</tr>
	<tr>
		<td class="dark"><b><a href="$dcadmin?action=edit_links">Edit Listing</a></b>
		</td><td class="lite">
		Use this option to edit existing listing
		</td>
		</tr>
	<tr>
		<td class="dark"><b><a href="$dcadmin?action=remove_links">Remove Listing</a></b>
		</td><td class="lite">
		Use this option to edit existing listing
		</td>
		</tr>
		</table>
		~;

}


